SystemOrganization addCategory: 'ConfigurationOftODE'!

Object subclass: #ConfigurationOftODE
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOftODE'!

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOftODE class methodsFor: 'metacello tool support' stamp: 'dkh 5/22/2011 12:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOftODE class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^self new project! !

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOftODE methodsFor: 'baselines' stamp: 'dkh 05/21/2011 10:37'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://seaside.gemstone.com/ss/Naviode'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Base' 'JQuery-UI');
					repository: 'http://www.squeaksource.com/Seaside30' ].
		spec project: 'JQueryWidgetBox' with: [
				spec
					className: 'ConfigurationOfJQueryWidgetBox';
					versionString: #'bleedingEdge';
					loads: #('JQWidgetBox-UILayout-Core');
					repository: 'http://www.squeaksource.com/JQueryWidgetBox' ].
		spec 
			package: 'tODE-Core' with: [
				spec includes: #('tODE-Seaside') ];
			package: 'tODE-Code' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Debugger' with: [
				spec requires: #('tODE-Inspector') ];
			package: 'tODE-Help' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Inspector' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Metacello' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Search' with: [
				spec requires: #('tODE-Inspector') ];
			package: 'tODE-Seaside' with: [
				spec requires: #('tODE-Core' 'Seaside30' 'JQueryWidgetBox') ];
			package: 'tODE-TestCase' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Views' with: [
				spec requires: #('tODE-Core') ];
			package: 'tODE-Workspace' with: [
				spec requires: #('tODE-Views') ];
			package: 'tODE-Tests-Core' with: [
				spec requires: #('tODE-Core') ]. ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Code' with: [
				spec includes: #('tODE-Pharo-Code') ];
			package: 'tODE-Core' with: [
				spec includes: #('tODE-Pharo-Core') ];
			package: 'tODE-Debugger' with: [
				spec includes: #('tODE-Pharo-Debugger') ];
			package: 'tODE-Search' with: [
				spec includes: #('tODE-Pharo-Search') ];
			package: 'tODE-Seaside' with: [
				spec includes: #('tODE-Pharo-Seaside') ];
			package: 'tODE-Views' with: [
				spec includes: 'tODE-Pharo-Views'];
			package: 'tODE-Pharo-Code' with: [
				spec requires: 'tODE-Code'];
			package: 'tODE-Pharo-Core' with: [
				spec requires: 'tODE-Core'];
			package: 'tODE-Pharo-Debugger' with: [
				spec requires: 'tODE-Debugger'];
			package: 'tODE-Pharo-Search' with: [
				spec requires: 'tODE-Search'];
			package: 'tODE-Pharo-Seaside' with: [
				spec requires: 'tODE-Seaside'];
			package: 'tODE-Pharo-Views' with: [
				spec requires: 'tODE-Views'];
			yourself.
	 ].

	spec for: #'gemstone' do: [
		spec project: 'WAObjectLogTable' copyFrom: 'Seaside30' with: [
				spec loads: #('Seaside-GemStone-Tools-Production')];
			project: 'JQGrid' copyFrom: 'JQueryWidgetBox' with: [
				spec loads: #('JQWidgetBox-JQGrid-Core') ].
		spec 
			package: 'tODE-Code' with: [
				spec includes: #('tODE-GemStone-Code') ];
			package: 'tODE-Core' with: [
				spec includes: #('tODE-GemStone-Core') ];
			package: 'tODE-Debugger' with: [
				spec includes: #('tODE-GemStone-Debugger') ];
			package: 'tODE-Inspector' with: [
				spec includes: #('tODE-GemStone-Inspector') ];
			package: 'tODE-Search' with: [
				spec includes: #('tODE-GemStone-Search') ];
			package: 'tODE-Seaside' with: [
				spec includes: #('tODE-GemStone-Seaside') ];
			package: 'tODE-Views' with: [
				spec includes: 'tODE-GemStone-Views'];
			package: 'tODE-GemStone-Code' with: [
				spec requires: 'tODE-Code'];
			package: 'tODE-GemStone-Core' with: [
				spec requires: 'tODE-Core'];
			package: 'tODE-GemStone-Debugger' with: [
				spec requires: 'tODE-Debugger'];
			package: 'tODE-GemStone-Inspector' with: [
				spec requires: 'tODE-Inspector'];
			package: 'tODE-GemStone-Search' with: [
				spec requires: 'tODE-Seaside'];
			package: 'tODE-GemStone-Seaside' with: [
				spec requires: 'tODE-Search'];
			package: 'tODE-GemStone-Views' with: [
				spec requires: 'tODE-Views'];
			package: 'tODE-GemTools' with: [
				spec requires: #('tODE-Inspector' 'WAObjectLogTable' 'JQGrid') ];
			yourself.
	 ].
! !

!ConfigurationOftODE methodsFor: 'symbolic versions' stamp: 'dkh 5/22/2011 12:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOftODE methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOftODE methodsFor: 'versions' stamp: 'dkh 05/21/2011 10:37'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- checkpoint ... fleshing out the inspector
- KISSing
- get selected center tab indx logic straightened out
- add frame link to basic inspector view for an object
- inverse frame lookup to reuse frame state and object state
- eliminate frameIndex
0.1 (dkh.7):
- rearrange inspector pane
0.1 (dkh.8):
- getting started on tODE class browser
- tweak inspector
0.1 (dkh.9):
- tweaks
0.1 (dkh.10):
- TOTabSpec keeps the receiver and frame state itself
- added frame tab for inspecting the tODE subsystem
- added explorer view for class tab ... 
0.1 (dkh.11):
- in class explorer, clicking on class should browse refs, like the instance variables ...
0.1 (dkh.12):
- get started on method browser
0.1 (dkh.13):
- change the default application path...
0.1 (dkh.14):
- basic method viewing is implemented ...
0.1 (dkh.15):
- superclass navigation and method browser
0.1 (dkh.16):
- use accordion for method categories in sidebar
0.1 (dkh.17):
- class hierarchy sidebar
0.1 (dkh.18):
- first cut at sanitization in prep for GemStone port
0.1 (dkh.19):
- starting GemStone port
0.1 (dlh.20):
- continued gemstone port
- start adding workspace
0.1 (dkh.21):
- basic port to GemStone complete
0.1 (dkh.24):
- getting TOWorkspace view working ... todo: doit/inspecit
0.1 (dkh.25):
- worksapce is basically working now (safari and chrome)
0.1 (dkh.26):
- use buttons for certain links...
0.1 (dkh.27):
- navigation buttons
0.1 (dkh.28):
- straighten out the inspector ...
0.1 (dkh.29):
- add doit button to workspace 
- push:selecting: propogation
0.1 (dkh.30):
- send message button 
- bookmark button
- extra content ... select: function on collections
0.1 (dkh.31):
- getting started on error hanlding for expression evaluation
0.1 (dkh.32):
- progress on debugger
0.1 (dkh.33):
- debugger/inspector is coming together
0.1 (dkh.34):
- seaside error handlers call TODebugger
0.1 (dkh.35):
- big refactoring ... specifiy the rendererClass (view class) in the tabSpec and make it possible to access renderer independent of rendering ... to set state for example prior to rendering,,,
0.1 (dkh.36):
- tweak
0.1 (dkh.37):
- bookmarks implemented ... first cut
0.1 (dkh.38):
- start work on test case tab 
0.1 (dkh.38):
- hook up debugger to test runner
- fix test
0.1 (dhk.40):
- misc stuff
- start on search page
0.1 (dkh.41):
- search basics complete
- bare minimum for debugging errors during rendering phase
0.1 (dkh.42):
- save/cancel for mthod editor
0.1 (dkh.43):
- save buttons for class browser
0.1 (dkh.44):
- major repackaging
0.1 (dkh.45):
- STARTED DOING DEVELOPMENT IN tODE
- search button for search
- starting to add method category control ...
0.1 (dkh.46):
- method categorization
0.1 (dkh.47):
- getting started on Metacello tab
0.1 (dkh.48):
- missed pharo-specific search code
0.1 (dkh.51):
- bare minimum of functionality in gemstone
0.1 (dkh.52):
- a little bit of gardening
0.1 (dkh.53):
- preserve bookmarks across reset
- platform-specific window title
- metaclass navigation
0.1 (dkh.54):
- improve gemstone method implementors speed
- include space in tODE frame
0.1 (dkh.55):
- initial bookmarks defined by pragmas..
0.1 (dkh.56):
- fiddle with bookmarks
tweaks
0.1 (dkh.58):
- major refactoring: 
    TOSpace renamed to TOSession
    TOSystem added (to permit cross-namespace development)

0.1 (dkh.59):
- infant mortality after refactoring ... 
0.1 (dkh.60):
- finally got debug window to display only in workspace inspect contents but it is a start
0.1 (dkh.61):
- looks like I''ve got basic error handling solved (for pharo):
  TOException pushed on stack
  internal server error response
  javascript error handler in client that refreshes the view so that the TOException is visible
0.1 (dkh.62):
- integrate gemstone-specific changes needed since 0.1 (dkh.58)
0.1 (dkh.63):
- debugger is basically working in GemStone now!!
0.1 (dkh.64):
- gardening
- set error handler for tODE to TOSeasideErrorHandler, so that tODE can be used in production
0.1 (dkh.65):
- gear up for platform-specific home page
- get started on GemStone home page
0.1 (dkh.66):
- start works on GemTools home'.
		spec author: 'dkh'.
		spec timestamp: '05/21/2011 05:38:53'.
		spec 
			project: 'Seaside30' with: '3.0.5';
			project: 'JQueryWidgetBox' with: '1.9'.
		spec 
			package: 'tODE-Code' with: 'tODE-Code-dkh.9';
			package: 'tODE-Core' with: 'tODE-Core-dkh.35';
			package: 'tODE-Debugger' with: 'tODE-Debugger-dkh.4';
			package: 'tODE-Help' with: 'tODE-Help-dkh.1';
			package: 'tODE-Inspector' with: 'tODE-Inspector-dkh.4';
			package: 'tODE-Metacello' with: 'tODE-Metacello-dkh.5';
			package: 'tODE-Search' with: 'tODE-Search-dkh.2';
			package: 'tODE-Seaside' with: 'tODE-Seaside-dkh.25';
			package: 'tODE-TestCase' with: 'tODE-TestCase-dkh.4';
			package: 'tODE-Views' with: 'tODE-Views-dkh.38';
			package: 'tODE-Workspace' with: 'tODE-Workspace-dkh.3';
			package: 'tODE-Tests-Core' with: 'tODE-Tests-Core-dkh.4'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Pharo-Code' with: 'tODE-Pharo-Code-dkh.5';
			package: 'tODE-Pharo-Core' with: 'tODE-Pharo-Core-dkh.1';
			package: 'tODE-Pharo-Debugger' with: 'tODE-Pharo-Debugger-dkh.2';
			package: 'tODE-Pharo-Search' with: 'tODE-Pharo-Search-dkh.3';
			package: 'tODE-Pharo-Seaside' with: 'tODE-Pharo-Seaside-dkh.2';
			package: 'tODE-Pharo-Views' with: 'tODE-Pharo-Views-dkh.19'. ].

	spec for: #'gemstone' do: [
		spec 
			project: 'WAObjectLogTable' with: '3.0.5';
			project: 'JQGrid' with: '1.9'.
		spec 
			package: 'tODE-GemStone-Code' with: 'tODE-GemStone-Code-dkh.6';
			package: 'tODE-GemStone-Core' with: 'tODE-GemStone-Core-dkh.5';
			package: 'tODE-GemStone-Debugger' with: 'tODE-GemStone-Debugger-dkh.3';
			package: 'tODE-GemStone-Inspector' with: 'tODE-GemStone-Inspector-dkh.3';
			package: 'tODE-GemStone-Search' with: 'tODE-GemStone-Search-dkh.3';
			package: 'tODE-GemStone-Seaside' with: 'tODE-GemStone-Seaside-dkh.2';
			package: 'tODE-GemStone-Views' with: 'tODE-GemStone-Views-dkh.6';
			package: 'tODE-GemTools' with: 'tODE-GemTools-dkh.2'. ].
! !
